/*
 jGuard is a security framework based on top of jaas (java authentication and authorization security).
 it is written for web applications, to resolve simply, access control problems.
 version $Name$
 http://sourceforge.net/projects/jguard/

 Copyright (C) 2004  Charles GAY

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 jGuard project home page:
 http://sourceforge.net/projects/jguard/

 */
package net.sf.jguard.example.struts.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.sf.jguard.core.CoreConstants;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

/**
 *
 * action called when authentication failed.
 *
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 *
 */
public class AuthenticationFailedAction extends BaseAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
		HttpSession session = request.getSession();
		ActionErrors errors = new ActionErrors();
		// prevent bug when accessing directly to authorizationFailedURI without authenticate
		if ((Class) session.getAttribute(CoreConstants.LOGIN_EXCEPTION_CLASS) != null) {
			ActionMessage amClass = new ActionMessage(((Class) request.getAttribute(CoreConstants.LOGIN_EXCEPTION_CLASS))
					.getName(), false);
			ActionMessage amMessage = new ActionMessage((String) request.getAttribute(CoreConstants.LOGIN_EXCEPTION_MESSAGE),
					false);
			// the LOGIN_EXCEPTION_CLASS is not put in the errors mechanism to
			// hide to the final user the exception class => this is not a user concern,
			// and can be evaluated as a security risk (give information about what
			// security system is used to securize your webapp)
			// errors.add(HttpConstants.LOGIN_EXCEPTION_CLASS,amClass);
			errors.add(CoreConstants.LOGIN_EXCEPTION_MESSAGE, amMessage);
			saveMessages(request, errors);
		}
		return mapping.findForward("authenticationFailedOK");
	}

}
